std::vector::rbegin,std::vector::crbegin(3)

NAME
std::vector::rbegin,std::vector::crbegin - std::vector::rbegin,std::vector::crbegin

Synopsis
   reverse_iterator rbegin(); (until C++11)
   reverse_iterator rbegin() noexcept; (since C++11)
                        (until C++20)
   constexpr reverse_iterator rbegin() noexcept; (since C++20)
   const_reverse_iterator rbegin() const; (until C++11)
   const_reverse_iterator rbegin() const noexcept; (since C++11)
                        (until C++20)
   constexpr const_reverse_iterator rbegin() const noexcept; (since C++20)
   const_reverse_iterator crbegin() const noexcept; (since C++11)
                        (until C++20)
   constexpr const_reverse_iterator crbegin() const noexcept; (since C++20)
   Returns a reverse iterator to the first element of the reversed vector. It
   corresponds to the last element of the non-reversed vector. If the vector is empty,
   the returned iterator is equal to rend().
   range-rbegin-rend.svg

Parameters
   (none)

Return value
   Reverse iterator to the first element.

Complexity
   Constant.

Example
// Run this code
 #include <algorithm>
 #include <iostream>
 #include <numeric>
 #include <string>
 #include <vector>
 int main()
 {
     std::vector<int> nums {1, 2, 4, 8, 16};
     std::vector<std::string> fruits {"orange", "apple", "raspberry"};
     std::vector<char> empty;
     // Print vector.
     std::for_each(nums.rbegin(), nums.rend(), [](const int n) { std::cout << n << ' '; });
     std::cout << '\n';
     // Sums all integers in the vector nums (if any), printing only the result.
     std::cout << "Sum of nums: "
               << std::accumulate(nums.rbegin(), nums.rend(), 0) << '\n';
     // Prints the first fruit in the vector fruits, checking if there is any.
     if (!fruits.empty())
         std::cout << "First fruit: " << *fruits.rbegin() << '\n';
     if (empty.rbegin() == empty.rend())
         std::cout << "vector 'empty' is indeed empty.\n";
 }

Output:
 16 8 4 2 1
 Sum of nums: 31
 First fruit: raspberry
 vector 'empty' is indeed empty.

See also
   rend returns a reverse iterator to the end
   crend (public member function)
   (C++11)
   rbegin returns a reverse iterator to the beginning of a container or array
   crbegin (function template)
   (C++14)